<template>
    <q-page padding class="column ">
        <q-banner v-if="IsLoading" class="bg-primary text-white ">
            <div class="loading-banner">
                <div>{{ URL }}</div>
                <q-circular-progress
                    indeterminate
                    size="90px"
                    :thickness="0.2"
                    color="lime"
                    center-color="grey-8"
                    track-color="transparent"
                    class="q-ma-md"
                />
            </div>
        </q-banner>
        <q-banner v-else-if="Errored" inline-actions class="text-white bg-red">
            Failed to get information
            <template v-slot:action>
                <q-btn flat color="white" label="Return to main menu" to="/" />
            </template>
        </q-banner>
        <div v-else-if="Info" class="video-form">
            <q-img
                :src="Info.getThumbnailPicture()"
                :ratio="16 / 9"
                spinner-color="primary"
                spinner-size="82px"
                class="video-thumbnail"
                contain
            >
                <div class="absolute-bottom text-subtitle1 text-center">
                    {{ Info.getTitle() }}
                </div>
            </q-img>
            <div clas="browse_folder">
                <q-input
                    type="text"
                    v-model="OutPut"
                    label="Destination Folder"
                    disable
                />
                <!-- <q-icon name="folder" /> -->
            </div>
            <q-btn-group push class="format-button-list">
                <div
                    v-for="(option, index) in OptionList"
                    :key="`format-${index}`"
                    class="format-button"
                >
                    <q-btn
                        push
                        :label="option.Text"
                        @click="() => initiateDownload(option.FormatChoice)"
                    />
                    <q-icon
                        name="warning"
                        v-if="option.FormatList.length > 1"
                        class="format-button-warning"
                    />
                </div>
            </q-btn-group>
        </div>
    </q-page>
</template>

<script lang="ts">
import Vue from 'vue';
import * as library from 'videopiper2.app.library';
import * as ytdl from 'youtube-dl-dal';
import { remote } from 'electron';
import { FormatEnum } from 'videopiper2.app.library';

class DownloadVideoPageData {
    IsLoading = true;
    Errored = false;
    Info?: library.VideoInfo;
    OptionList: VideoOption[] = [];
    OutPut =
        remote.app.getPath('downloads') ??
        remote.app.getPath('videos') ??
        remote.app.getPath('documents');
}

class VideoOption {
    FormatList: string[] = [];
    Text = '';
    FormatChoice: keyof typeof FormatEnum = 'audio';
}

export default Vue.extend({
    props: {
        URL: String
    },
    data() {
        return new DownloadVideoPageData();
    },
    methods: {
        async loadInfo() {
            library.Logger.logInfo('Getting Info');
            try {
                const info = await library.getVideoInfo(this.URL);
                this.Info = info;

                library.Logger.logInfo('Success in getting info');
            } catch (e) {
                // eslint-disable-next-line @typescript-eslint/no-unsafe-member-access
                library.Logger.logError(e.message);
                this.Errored = true;
            } finally {
                this.IsLoading = false;
            }
            this.gatherFormats();
        },
        initiateDownload(typeofFormat: keyof typeof FormatEnum) {
            library.QueueManager.addVideoItem({
                choice: typeofFormat,
                url: this.URL,
                output: this.OutPut
            });
            void this.$router.push({
                path: '/queue'
            });
        },
        gatherFormats() {
            const audioFormat = this.Info?.getBestAudioFormat();

            const addVideoFormat = (
                format: ytdl.VideoInfo.Format,
                text: string,
                formatChoice: keyof typeof FormatEnum
            ) => {
                const option = new VideoOption();
                option.FormatList.push(format.format_id);
                if (format.acodec.toLowerCase() === 'none' && audioFormat) {
                    option.FormatList.push(audioFormat.format_id);
                }
                option.Text = text;
                option.FormatChoice = formatChoice;
                this.OptionList.push(option);
            };

            if (audioFormat) {
                addVideoFormat(audioFormat, 'MP3', 'audio');
            }
            const F_4k60 = this.Info?.getFormat['4K60']();
            if (F_4k60) {
                addVideoFormat(F_4k60, '4K - 60fps', '4K60');
            }

            const F_4k = this.Info?.getFormat['4K']();
            if (F_4k) {
                addVideoFormat(F_4k, '4K', '4K');
            }

            const F_1080p60 = this.Info?.getFormat['1080p60']();
            if (F_1080p60) {
                addVideoFormat(F_1080p60, '1080P - 60fps', '1080p60');
            }

            const F_1080p = this.Info?.getFormat['1080p']();
            if (F_1080p) {
                addVideoFormat(F_1080p, '1080P', '1080p');
            }

            const F_720p60 = this.Info?.getFormat['720p60']();
            if (F_720p60) {
                addVideoFormat(F_720p60, '720P - 60 fps', '720p60');
            }

            const F_720p = this.Info?.getFormat['720p']();
            if (F_720p) {
                addVideoFormat(F_720p, '720P', '720p');
            }

            const F_480p = this.Info?.getFormat['480p']();
            if (F_480p) {
                // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                // @ts-ignore
                addVideoFormat(F_480p, '480P', '480p');
            }

            const F_360p = this.Info?.getFormat['360p']();
            if (F_360p) {
                addVideoFormat(F_360p, '360P', '360p');
            }
        }
    },
    mounted() {
        void this.loadInfo();
    }
});
</script>

<style lang="scss" scoped>
.loading-banner {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
}
.video-form {
    display: flex;
    flex-direction: column;
}
.video-thumbnail {
    width: 100px;
    height: 300px;
    align-items: center;
    width: 100%;
    margin: 0 auto;
    flex-grow: 1;
    // place-items: middle;
}

.format-button-list {
    width: max-content;
    margin: auto;
    display: flex;
    flex-direction: row;
}
.format-button {
    position: relative;
}
.format-button-warning {
    position: absolute;
    right: 0px;
}
.browse_folder {
    display: flex;
    flex-direction: row;
}
</style>
